using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using System.IO;
using System.Diagnostics;
using Infragistics.Excel;
using System.Globalization;

namespace WindowsApplication14
{
    public partial class Form1 : Form
    {
        int iterations  = 0;
        int curWorckseet = 0;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraDataSource1.Band.Columns.Add("test", typeof(bool));
            for (int i = 0; i < 67050; i++)
            {
              
                this.ultraDataSource1.Rows.Add( new object[] {i,  i , "Decs " + i.ToString(), DateTime.Now, false});
            }
            //calculate the numbers of the sheets
            iterations = this.ultraDataSource1.Rows.Count / 65536;
        }
        

        private void button4_Click(object sender, EventArgs e)
        {
            ultraGridExcelExporter1.FileLimitBehaviour = Infragistics.Win.UltraWinGrid.ExcelExport.FileLimitBehaviour.TruncateData;
         
            Workbook book = new Workbook(WorkbookFormat.Excel97To2003);

            try
            {
                //call the export for every sheet
                for (int wsheet = 0; wsheet <= iterations; wsheet++)
                {
                    curWorckseet = wsheet;
                    Worksheet sheet = book.Worksheets.Add("Sheet " + wsheet.ToString());

                    ultraGridExcelExporter1.Export(ultraGrid1, sheet);
                }

                book.Save("excel.xls");

            }
            catch 
            {}
            Process.Start("excel.xls");
        }

        private void ultraGridExcelExporter1_InitializeRow(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.ExcelExportInitializeRowEventArgs e)
        {
            //export the rows that should be includet to the curent sheet
            if (!(curWorckseet * 65536 <= e.Row.Index && e.Row.Index <= curWorckseet * 65536 + 65536 +1))
            {
                e.SkipRow = true;  
            }
        }

        private void ultraGridExcelExporter1_HeaderRowExporting(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.HeaderRowExportingEventArgs e)
        {
            //hide the header
            e.Cancel = true;
        }
    }
}